田草博客

互联网田草博客


网友交流QQ群:11740834 需注明申请加入原因

微信 公众号:ByCAD

邮箱:tiancao1001x126.com
ByCAD,微信公众号
首页 | 普通 | 电脑 | AutoCAD | VB/VB.NET | FLash | 结构 | 建筑 | 电影 | BIM | 规范 | 软件 | ID
-随机-|-分布-
-博客论坛-|-﨣﨤﨧﨨-
-网站导航-|-规范下载-
-BelovedFLash欣赏-

用户登陆
用户:
密码:
 

站点日历
73 2024 - 3 48
     12
3456789
10111213141516
17181920212223
24252627282930
31


站点统计

最新评论



顺时针? 隐藏日志,无权浏览
未知 凸包   [ 日期:2022-01-29 ]   [ 来自:本站原创 ]  HTML
Imports Autodesk.AutoCAD.ApplicationServices.Application
Imports Autodesk.AutoCAD.Runtime
Imports Autodesk.AutoCAD.Geometry
Imports Autodesk.AutoCAD.EditorInput
Imports Autodesk.AutoCAD.DatabaseServices
Imports Autodesk.AutoCAD.ApplicationServices
Imports System.Collections.Generic

Namespace ConvexHull '凸包
    Public Class Commands
        Private _p0 As Point2d
        '顺时针
        Private Function Clockwise(ByVal p1 As Point2d, ByVal p2 As Point2d, ByVal p3 As Point2d) As Boolean
            Return ((p2.X - p1.X) * (p3.Y - p1.Y) - (p2.Y - p1.Y) * (p3.X - p1.X)) < 0.00000001
        End Function

        Private Function ComparePoints(ByVal p1 As Point2d, ByVal p2 As Point2d) As Integer
            If p1.IsEqualTo(p2) Then
                '点重合
                Return 0
            End If
            Dim d1 As Double = _p0.GetDistanceTo(p1)
            Dim d2 As Double = _p0.GetDistanceTo(p2)
            If d1 = 0.0 Then
                'p1到P0距离为0
                Return -1
            End If
            If d2 = 0.0 Then
                'p2到P0距离为0
                Return 1
            End If
            '夹角
            Dim cos As Double = (p2.X - _p0.X) / d2 - (p1.X - _p0.X) / d1
            If cos < -0.00000001 Then
                Return -1
            End If
            If cos > 0.00000001 Then
                Return 1
            End If
            Return d1.CompareTo(d2)
        End Function

        Private Function ConvexHull(ByVal pts As List(Of Point2d)) As List(Of Point2d)
            _p0 = pts(0)
            Dim i As Integer = 1
            While i < pts.Count
                Dim pt As Point2d = pts(i)
                If pt.Y < _p0.Y OrElse (pt.Y = _p0.Y AndAlso pt.X < _p0.X) Then
                    _p0 = pt
                End If
                i += 1
            End While
            pts.Sort(AddressOf ComparePoints)
            'Dim i As Integer = 1
            i = 1
            While i < pts.Count - 1
                While i > 0 AndAlso Clockwise(pts(i - 1), pts(i), pts(i + 1))
                    pts.RemoveAt(i)
                    i -= 1
                End While
                i += 1
            End While
            Return pts
        End Function

        <CommandMethod("TcTuBao")> _
        Public Sub TcTuBao()
            Dim doc As Document = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument
            Dim db As Database = doc.Database
            Dim ed As Editor = doc.Editor
            Dim acTypValAr(0) As TypedValue
            acTypValAr.SetValue(New TypedValue(DxfCode.Start, "POINT"), 0)
            Dim psr As PromptSelectionResult = ed.GetSelection(New SelectionFilter(acTypValAr))
            If psr.Status <> PromptStatus.OK Then
                Return
            End If
            Using tr As Transaction = db.TransactionManager.StartTransaction()
                Using pline As New Polyline()
                    Dim pts As New List(Of Point2d)()
                    For Each so As SelectedObject In psr.Value
                        Dim dbPt As DBPoint = CType(tr.GetObject(so.ObjectId, OpenMode.ForRead), DBPoint)
                        pts.Add(New Point2d(dbPt.Position.X, dbPt.Position.Y))
                    Next
                    Dim i As Integer = 0
                    While i < ConvexHull(pts).Count
                        pline.AddVertexAt(i, pts(i), 0.0, 0.0, 0.0)
                        i += 1
                    End While
                    pline.Closed = True
                    pline.SetDatabaseDefaults()
                    Dim btr As BlockTableRecord = CType(tr.GetObject(db.CurrentSpaceId, OpenMode.ForWrite), BlockTableRecord)
                    btr.AppendEntity(pline)
                    tr.AddNewlyCreatedDBObject(pline, True)
                    tr.Commit()
                End Using
            End Using
        End Sub
    End Class
End Namespace



暂时没有评论
发表评论 - 不要忘了输入验证码哦!
作者: 用户:  密码:   注册? 验证:  防止恶意留言请输入问题答案:1*2=?  
评论:

禁止表情
禁止UBB
禁止图片
识别链接
识别关键字

字体样式 文字大小 文字颜色
插入粗体文本 插入斜体文本 插入下划线
左对齐 居中对齐 右对齐
插入超级链接 插入邮件地址 插入图像
插入 Flash 插入代码 插入引用
插入列表 插入音频文件 插入视频文件
插入缩进符合
点击下载按钮 下标 上标
水平线 简介分割标记
表  情
 
Tiancao Blog All Rights Reserved 田草博客 版权所有
Copyright ©